
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity ADDSUB_8 is
port (
  A, B : in  STD_LOGIC_VECTOR(7 downto 0); 
  SEL  : in  STD_LOGIC; 
  Y    : out STD_LOGIC_VECTOR(7 downto 0); 
  C    : out STD_LOGIC );
end ADDSUB_8;

architecture ADDSUB_8_ARCH of ADDSUB_8 is
    signal b_int : STD_LOGIC_VECTOR(7 downto 0); 
    signal y_int : STD_LOGIC_VECTOR(8 downto 0);   
begin
    b_int <= B when SEL = '0' else not B; 
    y_int <= ("0" & A) + ("0" & b_int) + Sel; 

    Y <= y_int(7 downto 0); 
    C <= y_int(8);      
end ADDSUB_8_ARCH; 

