

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity COUNTER_8 is
Port (
  CLK : in  STD_LOGIC;                 
  CLR : in  STD_LOGIC;                
  LD  : in  STD_LOGIC;  
  CE  : in  STD_LOGIC;   
  D   : in  STD_LOGIC_VECTOR(7 downto 0); 
  Q   : out STD_LOGIC_VECTOR(7 downto 0) );
end COUNTER_8;

architecture COUNTER_8_ARCH of COUNTER_8 is
  signal q_int : STD_LOGIC_VECTOR(7 downto 0) := (others => '0');
begin

  process (CLK, CLR)
  begin
    if CLR='1' 
    then
      q_int <= (others => '0'); 
    elsif CLK='1' and CLK'event
    then
	   if CE='1'
		then 
        if LD='1' 
        then
          q_int <= D;        
        else
          q_int <= q_int + 1;       
        end if;
      end if;
    end if;		
  end process;

  Q <= q_int;
  
end COUNTER_8_ARCH;
