
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity REG_16 is
port (
  D   : in STD_LOGIC_VECTOR(15 downto 0);         
  Q   : out STD_LOGIC_VECTOR(15 downto 0);
  CLK : in STD_LOGIC;  
  CLR : in STD_LOGIC;
  CE  : in STD_LOGIC );
end REG_16;

architecture REG_16_ARCH of REG_16 is

  component REG_8
  port (
    D   : in STD_LOGIC_VECTOR(7 downto 0);         
    Q   : out STD_LOGIC_VECTOR(7 downto 0);
    CLK : in STD_LOGIC;  
    CLR : in STD_LOGIC;
    CE  : in STD_LOGIC);
  end component;

begin
  reg_low: REG_8 port map (
    D   => D(7 downto 0),      
    Q   => Q(7 downto 0),
    CLK => CLK,
    CLR => CLR,
    CE  => CE );

  reg_high: REG_8 port map (
    D   => D(15 downto 8),      
    Q   => Q(15 downto 8),
    CLK => CLK,
    CLR => CLR,
    CE  => CE );

end REG_16_ARCH;