
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity REG_8 is
port (
  D   : in STD_LOGIC_VECTOR(7 downto 0);         
  Q   : out STD_LOGIC_VECTOR(7 downto 0);
  CLK : in STD_LOGIC;  
  CLR : in STD_LOGIC;
  CE  : in STD_LOGIC );
end REG_8;

architecture REG_8_ARCH of REG_8 is

  component REG_4
  port (
    D   : in STD_LOGIC_VECTOR(3 downto 0);         
    Q   : out STD_LOGIC_VECTOR(3 downto 0);
    CLK : in STD_LOGIC;  
    CLR : in STD_LOGIC;
    CE  : in STD_LOGIC);
  end component;

begin
  reg_low: REG_4 port map (
    D   => D(3 downto 0),      
    Q   => Q(3 downto 0),
    CLK => CLK,
    CLR => CLR,
    CE  => CE );

  reg_high: REG_4 port map (
    D   => D(7 downto 4),      
    Q   => Q(7 downto 4),
    CLK => CLK,
    CLR => CLR,
    CE  => CE );

end REG_8_ARCH;