
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity RING_COUNTER_3 is
port (
  CLK : in STD_LOGIC;                 
  RST : in STD_LOGIC;           
  Q   : out STD_LOGIC_VECTOR(2 downto 0));
end RING_COUNTER_3;

architecture RING_COUNTER_3_ARCH of RING_COUNTER_3 is
  signal q_int : STD_LOGIC_VECTOR(2 downto 0);
begin
  process (CLK, RST)
  begin
    if RST = '1' 
    then
      q_int <= "001";          
    elsif CLK='1' and CLK'event
    then
      q_int <= q_int(1 downto 0) & q_int(2); 
    end if;
  end process;

  Q <= q_int;

end RING_COUNTER_3_ARCH;
